import {Component, EventEmitter, OnInit, Output} from '@angular/core';
import {
    FormBuilder,
    FormGroup,
    Validators
} from '@angular/forms';
import { OverAllService } from "../../overAll/overAll.service";
import { NzMessageService } from "ng-zorro-antd";

@Component({
  selector: 'smart-basic-edit',
  templateUrl: './basic-edit.component.html',
  styles: []
})
export class BasicEditComponent implements OnInit {
    @Output() done = new EventEmitter<string>();
    modalTitle;    //modal标题
    nzSize = 'large';
    hostId;    //主机ID
    style = {
        display   : 'block',
        height    : '30px',
        lineHeight: '30px'
    };
    radioValue;

    tempList = [];  //模版列表

    validateForm;
    groupList = [];

    //折叠面板
    panel1 = { name:'配置IPMI',active:true };
    panel2 = { name:'配置宏',active:true };

    //加密
    otherHost;

    isBasicEdit = false;
    tabNum:number;    //tabs面板的序列号
    macroList = [      //配置宏数组
        {
            macro:'{$SNMP_COMMUNITY}',
            value:'public',
        }
    ];
    interfaceslist = [
        {
            main:'1',
            ip:'',
            dns:'',
            type:'1',
            port:'10050',
            useip:1,
        }
    ];  //接口数组
    macroTYpe = 'macro';      //宏tabs
    mainHost = 'hostType1';      //主机tabs
  constructor(private fb: FormBuilder,private overAllSer: OverAllService,
              private message: NzMessageService) { }

  ngOnInit() {
      this.tabNum = 0;
      // this.isBasicEdit = true;
      this.validateForm ={
          groups: [],
          hostExtend:{
              equipmentType: null,
              secondLevelType: null,
              serviceid:""
          },
          macros:this.macroList,
          interfaces:this.interfaceslist,  //接口
          inventory:{
              os:null,
              name:null,
              serialno_a:null
          },
          templates:[],
          name: null,
          host: null,
          ipmi_authtype:null,
          ipmi_username:null,
          ipmi_privilege:null,
          ipmi_password:null,
          tls_psk_identity:null,
          tls_issuer:null,
          tls_subject:null,
          tls_psk:null,
      }
  }

  //新增
    showModal(hostId,name,gId): void {
        this.groupList = [];
        if( gId ){
          const gObj = {
              label: name,value:gId,checked:true
          };
          this.groupList.push(gObj);
      }else{
          this.overAllSer.getgroups({}).subscribe(
              (res)=>{
                  for(let i = 0;i<res.data.length;i++){
                      const gObj = {
                          label: res.data[i].name,value:res.data[i].groupid,checked:false
                      };
                      this.groupList.push(gObj);
                  }
              }
          )
      }

        this.modalTitle = '添加资源';
        this.hostId = hostId;
        this.tabNum = 0;
        this.isBasicEdit = true;
        this.getTemplate();
        this.validateForm ={
            groups: [],
            hostExtend:{
                equipmentType: null,
                secondLevelType: null,
                serviceid:""
            },
            macros:this.macroList,
            interfaces:this.interfaceslist,  //接口
            inventory:{
                os:null,
                name:null,
                serialno_a:null
            },
            templates:[],
            name: null,
            host: null,
            ipmi_authtype:null,
            ipmi_username:null,
            ipmi_privilege:null,
            ipmi_password:null,
            tls_psk_identity:null,
            tls_issuer:null,
            tls_subject:null,
            tls_psk:null,
        }
    }

    //编辑
    editModal(hostId,name,gId): void{
        this.groupList = [];
        if( gId ){
            const gObj = {
                label: name,value:gId,checked:true
            };
            this.groupList.push(gObj);
        }else{
            this.overAllSer.getgroups({}).subscribe(
                (res)=>{
                    for(let i = 0;i<res.data.length;i++){
                        const gObj = {
                            label: res.data[i].name,value:res.data[i].groupid,checked:false
                        };
                        this.groupList.push(gObj);
                    }
                }
            )
        }

        this.hostId = hostId;
        this.modalTitle = '编辑资源';
        this.tabNum = 0;
        this.isBasicEdit = true;
        this.getTemplate();
        this.overAllSer.findDetailed(this.hostId).subscribe(
          (res)=>{
                this.validateForm = res.data[0];
                this.validateForm.ipmi_authtype = res.data[0].ipmi_authtype +"";
                this.validateForm.ipmi_privilege = res.data[0].ipmi_privilege +"";
                this.interfaceslist = res.data[0].interfaces;
                // console.log(this.validateForm);
                // this.message.info(res.errMsg);
          }
      )
    }

    handEditleOk(): void {
        //获取分组id
        let groupArr = [];
        for( let i = 0; i< this.groupList.length; i++ ){
            if(this.groupList[i].checked == true){
                const groupid = {"groupid":this.groupList[i].value}
                groupArr.push(groupid);
            }
        }
        this.validateForm.groups = groupArr;
        this.overAllSer.createHost(this.validateForm).subscribe(
            (res)=>{
                if(res.errCode == 10000){
                    this.isBasicEdit = false;
                }
                this.done.emit();
                this.message.info(res.errMsg);
            },
            (err)=>{
               this.message.info("系统错误");
            }
        )
    }

    handleEditCancel(): void {
        this.isBasicEdit = false;
    }

    //tabs切换
    tabsChange(num){
      console.log('tabs:' +num);
      this.tabNum = num;
    }

    //获取模版
    getTemplate(){
      this.overAllSer.templates().subscribe(
          (res)=>{
              this.tempList = res.apiResponse.data;
          }
      )
    }

    //接口add
    addInterfaces(){
        const demo =  {
            main:'1',
            ip:'',
            dns:'',
            type:'1',
            port:'10050',
            useip:1,
        };
       this.interfaceslist.push(demo);
    }

    deleteInterfaces(index){
      this.interfaceslist.splice(index,1);
    }

    // agent:10050
//     SNMP:161
//   JMX:12345
//     IPMI:623
    changePort(index){
      console.log(this.interfaceslist);
      switch (this.interfaceslist[index].type){
          case '1':{
              this.interfaceslist[index].port = '10050';
              break;
          }
          case '2':{
              this.interfaceslist[index].port = '161';
              break;
          }
          case '3':{
              this.interfaceslist[index].port = '12345';
              break;
          }
          case '4':{
              this.interfaceslist[index].port = '623';
              break;
          }
      }
    }

}
