import { HttpClient } from "@angular/common/http";
import {Observable} from "rxjs/Rx";
import { Injectable } from '@angular/core';
import {SERVER_API_URL} from "../app.constants";

@Injectable()
export class OverAllService {

    constructor(private http: HttpClient) {
    }

    //资源列表--所有类型
    find(data): Observable<any>{
        return this.http.post(SERVER_API_URL + '/host/find',data);
    }

    //停止-开启监控
    stopOrOpen(data): Observable<any>{
        return this.http.get(SERVER_API_URL + '/iomsp/host/stopOrOpen/',data);
    }

    //批量停止开启监控接口
    batchStopOrOpen(data): Observable<any>{
        return this.http.post(SERVER_API_URL + '/host/batchStopOrOpen',data);
    }

    //资源列表--资源分组
    findGroup(): Observable<any>{
        return this.http.get(SERVER_API_URL + '/groups/getAll');
    }

    //资源列表--设备类型
    findType(): Observable<any>{
        return this.http.get(SERVER_API_URL + '/host/selectAllEquipmentType');
    }

    //资源列表--查询主机
    findDetail(data): Observable<any>{
        return this.http.post(SERVER_API_URL + '/host/find',data);
    }

    //资源详情
    findDetailed(data): Observable<any>{
        return this.http.get(SERVER_API_URL + '/host/findDetailed/'+ data);
    }

    //平均响应时间
    responseTime(data): Observable<any>{
        return this.http.get(SERVER_API_URL + '/host/responseTime/'+ data);
    }

    //丢包率
    losed(data): Observable<any>{
        return this.http.get(SERVER_API_URL + '/host/losed/'+ data );
    }

    //CPU使用率
    cupUsed(data): Observable<any>{
        return this.http.get(SERVER_API_URL + '/host/cpuUsed/'+ data.hostId+ "/"+ data.hostType);
    }

    //内存使用率
    used(data): Observable<any>{
        return this.http.get(SERVER_API_URL + '/host/used/'+  data.hostId+ "/"+  data.hostType);
    }

    //磁盘使用率
    disks(data): Observable<any>{
        return this.http.get(SERVER_API_URL + '/host/disks/'+  data.hostId+ "/"+  data.hostType);
    }

    //进出口流量    --交换机
    inOutInfosnmp(data): Observable<any>{
        return this.http.get(SERVER_API_URL + '/host/inOutInfo/'+ data);
    }

    //进出口流量    --
    inOutInfoAgent(data): Observable<any>{
        return this.http.get(SERVER_API_URL + '/host/inOutInfoAgent/'+ data);
    }

    //主机接口
    getinterface(data): Observable<any>{
        return this.http.get(SERVER_API_URL + '/hostInterface/getinterface/'+ data);
    }

    //查询键值
    zabbixKey(data): Observable<any>{
        return this.http.get(SERVER_API_URL + '/zabbixKey/find/'+ data);
    }

    //创建监控点
    create(data): Observable<any>{
        return this.http.post(SERVER_API_URL + '/item/create', data);
    }

    //删除资源--get
    deleteHostGet(data): Observable<any>{
        return this.http.get(SERVER_API_URL + '/host/deleteHost/'+ data);
    }

    //删除资源--post
    deleteHostPost(data): Observable<any>{
        return this.http.post(SERVER_API_URL + '/host/deleteHost', data);
    }

    //添加资源
    createHost(data): Observable<any>{
        return this.http.post(SERVER_API_URL + '/host/create', data);
    }

    //获取分组信息
    getgroups(data): Observable<any>{
        return this.http.post(SERVER_API_URL + '/groups/getgroups', data);
    }

    //模版信息
    templates(): Observable<any>{
        return this.http.get(SERVER_API_URL + '/templates');
    }

    //添加分组
    createGroup(data): Observable<any>{
        return this.http.post(SERVER_API_URL + '/groups/create',data);
    }

    //删除分组
    deleteGroup(data): Observable<any>{
        return this.http.post(SERVER_API_URL + '/groups/delete',data);
    }

    //删除监控项
    deleteItem(data): Observable<any>{
        return this.http.post(SERVER_API_URL + '/item/deleteItem',data);
    }

    //监控设备数
    findSize(): Observable<any>{
        return this.http.get(SERVER_API_URL + '/host/findSize');
    }

    //监测点列表
    findCheck(data): Observable<any>{
        return this.http.get(SERVER_API_URL + '/item/find/' +data);
    }

    //监测点列表--type
    findCheckByType(data): Observable<any>{
        return this.http.post(SERVER_API_URL + '/item/find/' ,data);
    }

    //监控项分类
    findItemType(data): Observable<any>{
        return this.http.post(SERVER_API_URL + '/application/find' ,data);
    }

    //新增监控项分类
    createItemType(data): Observable<any>{
        return this.http.post(SERVER_API_URL + '/application/create' ,data);
    }


    //监测点状态统计
    findItemCount(data): Observable<any>{
        return this.http.get(SERVER_API_URL + '/item/findItemCount/' +data);
    }

    //监测点图形数据
    findGraphData(data): Observable<any>{
        return this.http.get(SERVER_API_URL + '/graph/findGraphData/' +data);
    }

    //监控项编辑
    itemUpdate(data): Observable<any>{
        return this.http.put(SERVER_API_URL + '/item/updata/' , data);
    }

}

